import javax.swing.*;
import java.awt.event.*;

public class Clock 
{
  // number of ticks to be performed and their delay in milliseconds
  private static final int TICKS = 20; 
  private static final int DELAY = 500;
  
  public static void main(String[] args)
  {
    // create and register listener
    ClockListener listener = new ClockListener();
    Timer timer = new Timer(DELAY, listener);
    
    // run program until window is closed
    timer.start();
    try 
    { 
      synchronized(timer) { timer.wait(); }
    }
    catch(InterruptedException e)
    { }
  }
  
  private static class ClockListener implements ActionListener
  {
    // number of ticks performed so far
    private int ticks = 0;
    
    // execute animation step
    public void actionPerformed(ActionEvent e) 
    {
      System.out.println(ticks);
      ticks++;
      if (ticks == TICKS)
      {
        // terminate program when all ticks have been performed
        System.out.println("done");
        System.exit(0);
      }
    }
  }
}
