// ----------------------------------------------------------------------------
// Exams.java
// analyzing the grades of exams
// 
// Author:  Wolfgang Schreiner <Wolfgang.Schreiner@fhs-hagenberg.ac.at>
// Created: August 20, 2001
// ----------------------------------------------------------------------------
public class Exams
{
  // --------------------------------------------------------------------------
  // user repeatedly enters exam grades in the range 1..5 or 0 to denote end
  // system prints number of grades, best, worst and average grade and
  // then asks the user whether to proceed with another exam or not.
  // --------------------------------------------------------------------------
  public static void main(String[] args)
  {
    // process next data set until answer for another one is not 'y'
    char answer = 0;         
    do
    {
      // statistics values
      int count = 0;               // number of grades
      int sum = 0;                 // sum of grades
      int min = Integer.MAX_VALUE; // minimum grade encountered so far
      int max = Integer.MIN_VALUE; // maximum grade encountered so far

      // read and process exam
      while (true)
      {
        // read grade
        int grade = 0;
        while(true)
        {
          System.out.print("Enter grade " + (count+1) + " (0 when done): ");
          grade = Input.readInt();
          if (Input.isOkay() && 0 <= grade && grade <= 5) break;
          if (Input.hasEnded())
          {
            System.out.println("Unexpected end of input!");
            System.exit(-1);
          }
          System.out.println("Invalid input!");
          Input.clearError();
        }

        // check for end of data set
        if (grade == 0) break;

        // process grade
        count++;
        sum += grade;
        if (grade < min) min = grade;
        if (grade > max) max = grade;
      }

      // print results for data set
      System.out.println("\nNumber of grades: " + count);

      // these values are only valid, if there was at least one grade 
      if (count > 0)
      {
        System.out.println("Best grade: " + min);
        System.out.println("Worst grade: " + max);
        System.out.println("Average grade: " + (float)sum/(float)count);
      }
      System.out.println("");

      // ask whether to continue
      while(true)
      {
        System.out.print("Another exam (y/n)? ");		  
        answer = Input.readChar();
        if (Input.isOkay() && (answer == 'y' || answer == 'n')) break;
        if (Input.hasEnded())
        {
          System.out.println("Unexpected end of input!");
          System.exit(-1);
        }
        System.out.println("Invalid input!");
      }      
    } 
    while (answer == 'y');
  }
}







