// ----------------------------------------------------------------------------
// Table.java
// a growing table to which elements can added
// 
// Author:  Wolfgang Schreiner <Wolfgang.Schreiner@fhs-hagenberg.ac.at>
// Created: August 25, 2001
// ----------------------------------------------------------------------------
public class Table
{
  public int[] p = new int[1000]; // the table data
  public int l = 0;               // number of elements in p

  // --------------------------------------------------------------------------
  // adds an element 'e' into the table
  // --------------------------------------------------------------------------
  public void add(int e)
  {
    if (l == p.length) resize();
    p[l] = e;
    l = l+1;
  }

  // --------------------------------------------------------------------------
  // resize the data array to twice its size
  // --------------------------------------------------------------------------
  public void resize()
  {
    int l = p.length;
    int[] q = new int[2*l];
    for (int i = 0; i < l; i++)
      q[i] = p[i];
    p = q;
  }

  // --------------------------------------------------------------------------
  // returns the number of elements entered into the table
  // --------------------------------------------------------------------------
  public int getNumber()
  {
    return l;
  }

  // --------------------------------------------------------------------------
  // gets element number 'i' entered into the table (counting starts with 0)
  // --------------------------------------------------------------------------
  public int getElement(int i)
  {
    return p[i];
  }
}
